var tbVersion;

browser.ecodmsapi.log("Startup...");

browser.runtime.getBrowserInfo().then(function (info) {
    tbVersion=info.version;
});

var menuVisibleState = true;
var sendMenu = browser.menus.create({
  id: "sendToDms",
  title: browser.i18n.getMessage("sendToDms"),
  visible: true,
  contexts: ["page","message_list"],
  async onclick(info, tab) {
	
	console.log("Send to dms clicked");
	if (info.pageUrl)
	{
               
                
              
                
		browser.messageDisplay.getDisplayedMessages(tab.id).then(function (msgList) {
				
				var msgIds = new Array();
				for (var i = 0; i < msgList.length; i++)
				{
					msgIds[i]=msgList[i].id;
				}
			
				browser.ecodmsapi.ecoDMS_doArchive(msgIds);	
				
			});
	}
	else
	{
		var msgIds = new Array();
		for (var i = 0; i < info.selectedMessages.messages.length; i++)
		{
			msgIds[i]=info.selectedMessages.messages[i].id;
		}
		browser.ecodmsapi.ecoDMS_doArchive(msgIds);
	}
  }
  
},function(){console.log("Callback called.");});

browser.menus.onShown.addListener((info, tab) => {
		
		if (info.contexts.includes("message_list") || info.contexts.includes("page"))
		{
			var visible = false;
			if (info.contexts.includes("page"))
				visible = true;
			else
				visible = info.selectedMessages.messages.length>0;
		
			if (menuVisibleState!=visible)
			{
				menuVisibleState = visible;
				browser.menus.update("sendToDms", { visible: visible });
				browser.menus.refresh();
			}
		}
});

browser.browserAction.onClicked.addListener((tab) => 
{
    browser.browserAction.isEnabled({tabId: tab.id}).then(function(enabled) {
        if (enabled)
		{
			 browser.messageDisplay.getDisplayedMessages(tab.id).then(function (msgList) {
				
				var msgIds = new Array();
				for (var i = 0; i < msgList.length; i++)
				{
					msgIds[i]=msgList[i].id;
				}
			
				browser.ecodmsapi.ecoDMS_doArchive(msgIds);	
				
				
			});
            
		}
    });
    
    
});

browser.composeAction.onClicked.addListener((tab,info) => 
{
     browser.composeAction.isEnabled({tabId: tab.id}).then(function(enabled) {
        if (enabled)
            browser.ecodmsapi.ecoDMS_doSendAndArchive();
    });
});

browser.tabs.onUpdated.addListener((tabId,changeInfo,tab) => 
{
    browser.messageDisplay.getDisplayedMessages(tab.id).then(function (msgList) {
        
        let hasMessages = msgList.length > 0;
        
        //browser.menus.update("sendToDms", { visible: hasMessages });
        if (hasMessages)
            browser.browserAction.enable(tab.id);
        else
            browser.browserAction.disable(tab.id);
        
    });
    
    
    
    
});

var allattachmentMenu = browser.menus.create({
	id: "sendAllAttachmentToDms",
	title: browser.i18n.getMessage("attachmentsToDms"),
	visible: true,
	contexts: ["all_message_attachments"],
	async onclick(info,tab) {
		let tabs = await messenger.tabs.query({ active: true, currentWindow: true });
		let message = await messenger.messageDisplay.getDisplayedMessage(tabs[0].id);
		browser.ecodmsapi.ecoDMS_doArchiveAttachment(message.id,info.attachments);    
	}
},function(){console.log("All Attachment Callback called.");});

var attachmentMenu = browser.menus.create({
  id: "sendAttachmentToDms",
  title: browser.i18n.getMessage("attachmentToDms"),
  visible: true,
  contexts: ["message_attachments"],
  async onclick(info, tab) {
	
	let tabs = await messenger.tabs.query({ active: true, currentWindow: true });
	let message = await messenger.messageDisplay.getDisplayedMessage(tabs[0].id);
	browser.ecodmsapi.ecoDMS_doArchiveAttachment(message.id,info.attachments);    
  }
  
},function(){console.log("Attachment Callback called.");});

browser.composeScripts.register({js: [{file: "content/sendscript.js"}]});

async function scriptMessage(message) {
  
    browser.ecodmsapi.log("Got message: "+message.cmd);
    if (message.cmd == "register")
    {
        await browser.composeAction.disable();
        await browser.ecodmsapi.registerSendStateObserver();
    }
}

async function onCommand(cmd, state) {
    browser.ecodmsapi.log("onCommand: "+cmd+" / "+state);
    if (cmd === "sendButtonState")
    {
        if (state===true)
        {
            browser.composeAction.disable();
        }
        else
        {
            browser.composeAction.enable();
        }
        
        return state;
    }
    else if (cmd === "translate")
    {
        return browser.i18n.getMessage(state);
    }
    else if (cmd === "version")
    {
        return tbVersion;
    }
        
 
}

browser.ecodmsapi.onCommand.addListener(onCommand);
browser.runtime.onMessage.addListener(scriptMessage);

browser.ecodmsapi.log("Startup complete.");
