//var { Services } = ChromeUtils.import('resource://gre/modules/Services.jsm');
var { ExtensionCommon } = ChromeUtils.import("resource://gre/modules/ExtensionCommon.jsm");
//var { Services } = ChromeUtils.import("resource://gre/modules/Services.jsm");
var { FileUtils } = ChromeUtils.import("resource://gre/modules/FileUtils.jsm");
var { MailUtils } = ChromeUtils.import("resource:///modules/MailUtils.jsm");
var { MailServices } = ChromeUtils.import("resource:///modules/MailServices.jsm");
var { XPCOMUtils } = ChromeUtils.import("resource://gre/modules/XPCOMUtils.jsm");
var { ExtensionParent } = ChromeUtils.import("resource://gre/modules/ExtensionParent.jsm");
var { ExtensionSupport } = ChromeUtils.import("resource:///modules/ExtensionSupport.jsm");


async function checkMyFunc(uri,msgIdx)
{
	var fileTemplate = GenerateValidFilename("E-Mail"+msgIdx,".pdf");
	var pdfFile = FileUtils.File(PathUtils.join(PathUtils.tempDir, fileTemplate));
	pdfFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, FileUtils.PERMS_FILE);
	pdfFile.remove(false);

	var mymessenger = Components.classes["@mozilla.org/messenger;1"]
                                    .createInstance(Components.interfaces.nsIMessenger);
				
	
	let psService = Cc[
			"@mozilla.org/gfx/printsettings-service;1"
		].getService(Ci.nsIPrintSettingsService);

		let printSettings;
		if (psService.newPrintSettings) {
			printSettings = psService.newPrintSettings;
		} else {
			printSettings = psService.createNewPrintSettings();
		}
		
		printSettings.printSilent=true;

		if(printSettings.printToFile !== undefined)
		{
			printSettings.printToFile=true;
		}
		else
		{
			printSettings.outputDestination = 1; //file
		}

		printSettings.toFileName=pdfFile.path;
		printSettings.outputFormat=Components.interfaces.nsIPrintSettings.kOutputFormatPDF;
		printSettings.printBGImages = true;
		
		if(printSettings.showPrintProgress !== undefined)
		{
			printSettings.showPrintProgress = true;  
		}
  
		printSettings.printBGColors = true;
		printSettings.footerStrCenter = "";
		printSettings.footerStrLeft="";
		printSettings.footerStrRight="";
		printSettings.headerStrCenter = "";
		printSettings.headerStrLeft="";
		printSettings.headerStrRight="";
		printSettings.shrinkToFit=true;
	  
	  
	  try 
	  {
				const messageServiceFromURI = mymessenger.messageServiceFromURI || MailServices.messageServiceFromURI;
				var messageService = messageServiceFromURI(uri);
				let aMsgHdr = messageService.messageURIToMsgHdr(uri);
				await PrintUtils.loadPrintBrowser(messageService.getUrlForUri(uri).spec);
				await PrintUtils.printBrowser.browsingContext.print(printSettings);
				return pdfFile;
  	   } catch (ex) {
				console.log(ex);
		}
	  return null;
}


