var { ExtensionCommon } = ChromeUtils.import("resource://gre/modules/ExtensionCommon.jsm");
//var { Services } = ChromeUtils.import("resource://gre/modules/Services.jsm");
var { MailServices } = ChromeUtils.import("resource:///modules/MailServices.jsm");
var { FileUtils } = ChromeUtils.import("resource://gre/modules/FileUtils.jsm");
var { MailUtils } = ChromeUtils.import("resource:///modules/MailUtils.jsm");
var { XPCOMUtils } = ChromeUtils.import("resource://gre/modules/XPCOMUtils.jsm");
var { ExtensionParent } = ChromeUtils.import("resource://gre/modules/ExtensionParent.jsm");
var { ExtensionSupport } = ChromeUtils.import("resource:///modules/ExtensionSupport.jsm");
Cu.importGlobalProperties(['PathUtils']);


var currentMsg;
var uris;
var emailFile;
var pdfFile;
var pPath = null;
var mySubject = null;
var myDate = new Date();
var composeListener;
var ecodmsapi = null; 
var m_tabbedBrowser = null;
var isSendMail=false;
var messengerOLPath=null;

function ecoDMS_getWorkerPath()
{

                try
                {
                    if (pPath!=null)
                        return pPath;
                    else
                    {
                        var xulruntime=Components.classes["@mozilla.org/xre/app-info;1"]
                            .getService(Components.interfaces.nsIXULRuntime);

                        if(xulruntime.OS=="WINNT")
                        {
                            var wrk = Components.classes["@mozilla.org/windows-registry-key;1"]
                                                    .createInstance(Components.interfaces.nsIWindowsRegKey);

                            var printcomworkerpath=null;
                            wrk.open(wrk.ROOT_KEY_LOCAL_MACHINE,"SOFTWARE",wrk.ACCESS_READ);
                            if (wrk.hasChild("applord gmbh\\ecoDMS Printer"))
                            {
                                var subkey = wrk.openChild("applord gmbh\\ecoDMS Printer", wrk.ACCESS_READ);
                                printcomworkerpath= subkey.readStringValue("InstallPath");
                                subkey.close();
                            }
                            wrk.close();
                            if (printcomworkerpath===null)
                            {
                                wrk.open(wrk.ROOT_KEY_LOCAL_MACHINE,"SOFTWARE",wrk.ACCESS_READ);
                                if (wrk.hasChild("WOW6432Node\\applord gmbh\\ecoDMS Printer"))
                                {
                                    var subkey = wrk.openChild("WOW6432Node\\applord gmbh\\ecoDMS Printer", wrk.ACCESS_READ);
                                    printcomworkerpath= subkey.readStringValue("InstallPath");
                                    subkey.close();
                                }
                                wrk.close();
                            }

                            if (printcomworkerpath!==null)
                            {
                            printcomworkerpath=printcomworkerpath.replace("\"","");
                            printcomworkerpath=printcomworkerpath.replace("\"","");
                            printcomworkerpath=printcomworkerpath+"\\printcomworker.exe";
                            }
                            pPath=printcomworkerpath;
                            return printcomworkerpath;
                        }
                        else if (xulruntime.OS=="Darwin")
                        {
                            pPath="/Applications/ecoDMS Client.app/Contents/MacOS/printcomworker";
                            return pPath;
                        }
                        else
                        {
                            pPath="/opt/ecodms/ecodmsclient/printcomworker";
                            return pPath;
                        }
                    }
                }
                catch(err)
                {
                    return null;
                }
};

function ecoDMS_doSaveToArchive()
{
                
                
                if (m_tabbedBrowser!=null)
                    m_tabbedBrowser.removeCurrentTab();
                
                var executable = Components.classes["@mozilla.org/file/local;1"]
                                                    .createInstance(Components.interfaces.nsIFile);
                var process = Components.classes["@mozilla.org/process/util;1"]
                                                    .createInstance(Components.interfaces.nsIProcess);
                var printcomworkerpath = ecoDMS_getWorkerPath();

                if (printcomworkerpath==null)
                {
                    alert('Die E-Mail kann nicht archiviert werden, installieren sie den ecoDMS Printer!');
                    return;
                }


                if (printcomworkerpath=="/opt/ecodms/ecodmsclient/printcomworker")
                {
                    var env = Components.classes["@mozilla.org/process/environment;1"]
                                                    .getService(Components.interfaces.nsIEnvironment);
                    env.set("LD_LIBRARY_PATH","/opt/ecodms/ecodmsclient/");
                }

                executable.initWithPath(printcomworkerpath);
                process.init(executable);
				if (mySubject==null)
					mySubject="";
                var tsubject = unescape(encodeURIComponent(mySubject));
                tsubject = tsubject.replace(/#/g,'-');
                
                if (tsubject.length>255)
                    tsubject = tsubject.substr(0,255);
                
                
                let recentWindow = Services.wm.getMostRecentWindow("mail:3pane");
                //Mit datum: var args = new Array("-f",pdfFile.path,"-o",emailFile.path,"-p",btoa("0##"+tsubject+"######"+myDate.yyyymmdd()+"#"));
                var args = new Array("-f",pdfFile.path,"-o",emailFile.path,"-p",recentWindow.btoa("0##"+tsubject+"#"));
                var argscount=6;
                
                /*if (printcomworkerpath=="/Applications/ecoDMS Client.app/Contents/MacOS/printcomworker")
                {
                    args = new Array("-f",emailFile.path,"-pn",recentWindow.btoa("0##"+tsubject+"#"));
                    argscount=4;
                }*/
                
                process.runAsync(args,argscount,function(subject,topic,data)
				{
                    emailFile.remove(true);
                    emailFile=null;
                    pdfFile.remove(true);
                    pdfFile=null;
                    mySubject=null;
                    myDate = new Date();
                    currentMsg=currentMsg+1;
                    if(uris[currentMsg])
                        ecoDMS_doArchive(currentMsg);

                });
                
                
        };
        

function ecoDMS_onArchiveCommandWithSubject(msgUris,theSubject)
{
        mySubject=theSubject;
        currentMsg=0;
        uris=msgUris;
        ecoDMS_doArchive(currentMsg);
}

async function ecoDMS_doArchive(msgIdx)
{
     let recentWindow = Services.wm.getMostRecentWindow("mail:3pane");
	 var mymessenger = Components.classes["@mozilla.org/messenger;1"]
                                    .createInstance(Components.interfaces.nsIMessenger);
								 
	Services.scriptloader.loadSubScript("chrome://ecodms/content/messengerOL.js", recentWindow, "UTF-8");
		
	
			
	var fileTemplate = recentWindow.GenerateValidFilename("E-Mail"+msgIdx,".eml");
	emailFile = FileUtils.File(PathUtils.join(PathUtils.tempDir, fileTemplate));
    emailFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, FileUtils.PERMS_FILE);
    emailFile.remove(false);
	mymessenger.saveAs(uris[msgIdx],true,null,emailFile.path,true);
	
	const messageServiceFromURI = mymessenger.messageServiceFromURI || MailServices.messageServiceFromURI;
		
        try
        {
              mySubject = messageServiceFromURI(uris[msgIdx])
                                 .messageURIToMsgHdr(uris[msgIdx])
                                       .mime2DecodedSubject;
                                        
              var theDate = messageServiceFromURI(uris[msgIdx])
                                           .messageURIToMsgHdr(uris[msgIdx])
                                                .date;
                                    
               myDate = new Date(theDate/1000);
                            
        }
        catch (e)
        {
			console.log(e);
            mySubject="";
        }
         

         if (mySubject=="")
               mySubject="EMail";
		
			
	pdfFile = await recentWindow.checkMyFunc(uris[msgIdx],msgIdx);
	ecoDMS_doSaveToArchive();
			
	
	 
     
}


function myComposeListener()
{
    
}

function getMsgFolderFromUri(uri, checkFolderAttributes) 
{
     var myWindow = Services.wm.getMostRecentWindow("msgcompose");
    if (typeof MailUtils !== 'undefined' && MailUtils.getFolderForURI) {
      return MailUtils.getFolderForURI(uri, checkFolderAttributes);
    }
    else if (typeof MailUtils !== 'undefined' && MailUtils.getExistingFolder)
    {
        return MailUtils.getExistingFolder(uri, checkFolderAttributes);
    }
    else
        throw Exception("Unable to get Msg-Folder");
};

myComposeListener.prototype =
{
       isWorkaround: false,
       saveIsDone: false,
       NotifyComposeFieldsReady: function(){

           
       },
       ComposeProcessDone: function(aResult)
       {
            var myWindow = Services.wm.getMostRecentWindow("msgcompose");
                
            try
            {
                var gMsgCompose = myWindow.gMsgCompose;
                
                if (aResult===Components.results.NS_OK)
                {
                    if (gMsgCompose.messageSend.messageKey===4294967295)
                    {
                        this.isWorkaround=true;
                        SaveAsDraft();
                       
                       var threadManager = Components.classes["@mozilla.org/thread-manager;1"]
                         .getService(Components.interfaces.nsIThreadManager);
                       
                        var thread=threadManager.mainThread;
                        var thread2=threadManager.currentThread;
                        while(!saveIsDone)
                        {
                           thread.processNextEvent(1000);
                           thread2.processNextEvent(1000);
                        }
                       
                      
                        
                     
                    }
                    else
                    {
                     
                      var folder=gMsgCompose.savedFolderURI;
                      var theFolder=getMsgFolderFromUri(folder,false);
                      var msgKey=gMsgCompose.messageSend.messageKey;
                      var msgURIX = theFolder.generateMessageURI(msgKey);
                      var msgUris = new Array(msgURIX);
                      isSendMail=true;
                      ecoDMS_onArchiveCommandWithSubject(msgUris,gMsgCompose.compFields.subject);
                      this.unregister();
                      if (this.isWorkaround)
                      {
                       
                        var msgs = Components.classes["@mozilla.org/array;1"].createInstance(Components.interfaces.nsIMutableArray);
                        msgs.appendElement(theFolder.GetMessageHeader(msgKey),false);
                        theFolder.deleteMessages(msgs,null,true,false,null,false);
                        
                      }
                      this.saveIsDone=true;
                  }
              
               }       
               else
                   this.unregister();
               
               
            }
            catch (e)
            {
                myWindow.alert('Cannot send e-mail to archive! '+e);
            }
       },
       SaveInFolderDone: function(folderURI){
         
       },
       register: function()
       {
          var myWindow = Services.wm.getMostRecentWindow("msgcompose");
          myWindow.gMsgCompose.RegisterStateListener(this);
       },
       unregister: function()
       {
          var myWindow = Services.wm.getMostRecentWindow("msgcompose");
          myWindow.gMsgCompose.UnregisterStateListener(this);
       }
       
};

var listener = {
        
     mycallback: null,
     sendNotification: function(cmd,state)
     {
         return mycallback(cmd,state);
     },
     add: function(callback) {
        console.log("Callback added.");
        mycallback = callback;
     },
     remove: function(callback)
     {
        console.log("Callback removed.");
     }
    
};


ecodmsapi = class extends ExtensionCommon.ExtensionAPI {
    
     onStartup() {
            console.log("Do startup!");
            const aomStartup = Cc["@mozilla.org/addons/addon-manager-startup;1"].getService(Ci.amIAddonManagerStartup);
            const manifestURI = Services.io.newURI("manifest.json", null, this.extension.rootURI);
            this.chromeHandle = aomStartup.registerChrome(manifestURI, [
                        ["content", "ecodms", "content/"]
            ]);
     }
     
    onShutdown(isAppShutdown) {
        console.log("Do shutdown.");
        if (isAppShutdown) return;

        Services.obs.notifyObservers(null, "startupcache-invalidate");
        this.chromeHandle.destruct();
        this.chromeHandle = null;
        console.log("implementation.js: ecoDMS Addon shutdown");
    }
     
    getAPI(context) {
        
		messengerOLPath = context.extension.rootURI.resolve("content/messengerOL.js");
		
        //ecoDMS_checkAttachmentContextMenus(context);
        
        return {
            ecodmsapi: {
          ecoDMS_doArchive(msgIds)
          {
					  
			  let msgId=0;
			  uris = new Array();
			  for (var i=0;i<msgIds.length;i++)
			  {
				  let realMessage = context.extension.messageManager.get(msgIds[i]);
				  uris[i]=realMessage.folder.getUriForMsg(realMessage);
			  }
			  
              if (uris!=null && uris[0]!=null)
			  {
				currentMsg=0;
                ecoDMS_doArchive(msgId);
			  }

          },
        log(msg) {
          console.log(msg);
        },
		async ecoDMS_doArchiveAttachment(msgId, attachments)
		{
			for (let attachment of attachments)
			{
				await ecoDMS_doArchiveAttachment(msgId,attachment,context);
			}
			
		},
        ecoDMS_doSendAndArchive() {
            console.log("Register compose listener");
            var myWindow = Services.wm.getMostRecentWindow("msgcompose");
            composeListener = new myComposeListener();
            composeListener.register();
            myWindow.goDoCommand("cmd_sendButton");
        },
        registerSendStateObserver() {
            
            var myWindow = Services.wm.getMostRecentWindow("msgcompose");
            var sbutton = myWindow.document.getElementById("button-send");
            console.log("Got send button");
			listener.sendNotification("sendButtonState",sbutton.disabled);
          
            var observer = new myWindow.MutationObserver(function(mutations) {
                mutations.forEach(function(mutation) 
				{
					if (mutation.attributeName == "disabled")
					{
						listener.sendNotification("sendButtonState",mutation.target.disabled);
					}
				});    
          });
 
            var config = { attributes: true, childList: true, characterData: true };
            observer.observe(sbutton, config);
            
        },
        onCommand: new ExtensionCommon.EventManager({
          context,
          name: "myapi.onCommand",
          register(fire) 
          {
            function callback(cmd, state) {
              return fire.async(cmd, state);
          }

          listener.add(callback);
          return function() {
              listener.remove(callback);
           };
          },
        }).api(),
      },
    };
  }
  
  
};

async function ecoDMS_doArchiveAttachment(msgId,attachment,context)
{
	
			var executable = Components.classes["@mozilla.org/file/local;1"]
                                     .createInstance(Components.interfaces.nsIFile);
									 
			 var printcomworkerpath = ecoDMS_getWorkerPath();

			if (printcomworkerpath==null)
			{
				Services.prompt.alert(null, "Save Attachments", "Der Anhang kann nicht archiviert werden, installieren sie den ecoDMS Printer!");
				return;
			}
			
			let recentWindow = Services.wm.getMostRecentWindow("mail:3pane");
			let messenger = recentWindow.messenger;
			
			const messageServiceFromURI = MailServices.messageServiceFromURI || messenger.messageServiceFromURI;
			
			let msg = context.extension.messageManager.get(msgId);
			let messageUri = msg.folder.getUriForMsg(msg);
			let messageService = messageServiceFromURI(messageUri);
			let attachmentUriBase = messageService.getUrlForUri(messageUri).spec;
			
			
			var attachmentUrl = attachmentUriBase + (attachmentUriBase.indexOf('?') >= 0 ? "&" : "?") + `part=${attachment.partName}&filename=${encodeURI(attachment.name)}`;
					
			let [_, filenameWithoutExtension, filenameExtension] = attachment.name.match(/(.*)(\..*)$/) || [null, attachment.name, ""];
					
			var fileTemplate = recentWindow.GenerateValidFilename(filenameWithoutExtension.replace(/([^a-z0-9 ]+)/gi, ''),filenameExtension);
			var attachmentFile = FileUtils.File(PathUtils.join(PathUtils.tempDir, fileTemplate));
			attachmentFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, FileUtils.PERMS_FILE);
					
					
			let success = await new Promise(resolve => {
									let urlListener = {
										OnStartRunningUrl(url) { },
										OnStopRunningUrl(url, status) {
											resolve(Components.isSuccessCode(status));
										},
									};
									messenger.saveAttachmentToFile(
										attachmentFile,
										attachmentUrl,
										messageUri,
										attachment.contentType,
										urlListener
									);
								});
				
				if (!success)
				{
					Services.prompt.alert(null, "Save Attachments", "Could not save attachment, aborting.");
					return;
				}
				else
				{
					if (printcomworkerpath=="/opt/ecodms/ecodmsclient/printcomworker")
                    {
                        var env = Components.classes["@mozilla.org/process/environment;1"]
                                        .getService(Components.interfaces.nsIEnvironment);
                        env.set("LD_LIBRARY_PATH","/opt/ecodms/ecodmsclient/");
                    }
                    
					var process = Components.classes["@mozilla.org/process/util;1"]
                                        .createInstance(Components.interfaces.nsIProcess);
					
					executable.initWithPath(printcomworkerpath);
                    process.init(executable);

                    var args;
                    if (printcomworkerpath=="/opt/ecodms/ecodmsclient/printcomworker" || printcomworkerpath=="/Applications/ecoDMS Client.app/Contents/MacOS/printcomworker")
                        args = new Array("-f",unescape(encodeURIComponent(attachmentFile.path)),"-cl","-pn","0##"+unescape(encodeURIComponent(attachment.name))+"#");
                    else
                    {
                        args = new Array("-f",attachmentFile.path,"-cl","-pn","0##"+unescape(encodeURIComponent(attachment.name))+"#");
                    }

					let success = await new Promise(resolve => {

							try
							{
									process.runAsync(args,5,function(subject,topic,data){
										attachmentFile.remove(false);
										resolve(true);
									});
							}
							catch(e)
							{
								resolve(false);
							}
									
						});
				}
								
			
};

